$script = <<-SCRIPT
add-apt-repository -y ppa:longsleep/golang-backports
apt-get update
apt-get upgrade -y
apt-get install -y golang-go linux-tools-virtual linux-tools-generic linux-tools-$(uname -r) libc6-dbg build-essential bpftrace jq

git clone https://github.com/redis/redis /opt/redis
(cd /opt/redis && git checkout 5.0.9 && make CFLAGS='-fno-omit-frame-pointer')

ln -s /opt/redis/src/redis-server /usr/local/bin/redis-server

echo 'vm.overcommit_memory = 1' >> /etc/sysctl.conf
echo 'echo never > /sys/kernel/mm/transparent_hugepage/enabled' >> /etc/rc.local

wget -q -O /usr/local/bin/flamegraph.pl https://github.com/brendangregg/FlameGraph/raw/master/flamegraph.pl
wget -q -O /usr/local/bin/stackcollapse-perf.pl https://github.com/brendangregg/FlameGraph/raw/master/stackcollapse-perf.pl
chmod +x /usr/local/bin/*.pl
SCRIPT

Vagrant.configure(2) do |config|
  config.vm.box = "bento/ubuntu-20.04"
  config.vm.hostname = "devm"
  #config.vm.network "private_network", type: "dhcp"

  config.vm.provider "virtualbox" do |v|
    v.memory = 1024
    v.cpus = 2
  end

  config.vm.provision "shell", inline: $script
end
